﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RefactoredBrushUp
{
    public class Student : Person, IStudent
    {
        public int Semester { get; set; }


        public void ValidateSemester()
        {
            if (Semester < 1 || Semester > 8) throw new ArgumentOutOfRangeException("Semester must be minimum 1 and maximum 8: " + Semester);
        }

        public void Validate()
        {
            base.ValidateName();
            ValidateSemester();
        }

        public override string ToString()
        {
            return $"{{{base.ToString()}, {nameof(Semester)}={Semester.ToString()}}}";
        }

        public override bool Equals(object? obj)
        {
            return obj is Student student &&
                   base.Equals(obj) &&
                   Semester == student.Semester;
        }

        public override int GetHashCode()
        {
            return HashCode.Combine(base.GetHashCode(), Semester);
        }
    }
}
